#MenuTitle: Show Component Property Value
# -*- coding: utf-8 -*-
__doc__="""
Glyphs script for showing the value of the requested smart component property
"""
# Author : todoi
# Date : 2019/02/01

from GlyphsApp import *


componentSearch ='_partT1.V-ddigeut-2a' # change here!
propertyToLookFor='Width' # change here!
# glyph selection is needed
if len(Glyphs.font.selectedLayers)==0:
    print('Select some glyphs first')

#for glyphs e.g.) 'Ddag-ko','Ddarh-ko',...
for layer in Glyphs.font.selectedLayers:
    #for components e.g.) dot, stem, ttigeut, ...
    for component in layer.components:
        if component.componentName==componentSearch:
            #try to return the value of seeked property
            try:
                # first %s: glyph name
                # second %s: property that you required
                # final %d: value of that property
                print('Glyph:%s, %s Value: %d' %(unichr(int(layer.parent.unicode,16)),propertyToLookFor,component.smartComponentValues[propertyToLookFor]))
            #KeyError occurs in 2 circumstances
            #1st: the value of the property is at the maximum: BUG
            #2nd: there's no such property
            except KeyError:
                #if there was actually a propery that you required
                myBoolean=True
                #look up all smartComponets one more time
                for axis in component.component.smartComponentAxes:
                    #if there was one, then, it might had a maximum value
                    if axis.name==propertyToLookFor:
                        print('Glyph:%s, %s Value: %d' %(unichr(int(layer.parent.unicode,16)),propertyToLookFor,axis.topValue))
                        myBoolean=False
                        break
                #if there is not, then you probably entered a wrong property name
                if myBoolean:
                    print('Glyph:%s, the glyph has no such property: %s'%(unichr(int(layer.parent.unicode,16)),propertyToLookFor))